<?php
 /**
 * @package jlvklike
 * @author Anton Voynov (anton@joomline.net)
 * @version 1.2
 * @copyright (C) 2010 by Anton Voynov(http://www.joomline.net)
 * @license JoomLine: http://joomline.net/licenzija-joomline.html
 *
*/
/**
 * Jlvkcomments
 *
 * @version 1.3
 * @author Anton Voynov (anton@joomline.ru)
 * @copyright (C) 2010 by Anton Voynov(http://www.joomline.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 **/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );


class plgContentJlvklike extends JPlugin
{

	function plgContentJlvklike( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		$plugin			=& JPluginHelper::getPlugin('content', 'jlvklike');
		$this->params	= new JParameter( $plugin->params );

	}

	function onPrepareContent( &$row, &$params, $limitstart ) {
		global $jlvklikeinit;
		$apiId 				= $this->params->get('apiId');
		$width 				= $this->params->get('width');
		$autoAddOnlyFull 	= $this->params->get('autoAddOnlyFull') == 1 ? true : false;
		$position 			= $this->params->get('position');
		$max_words			= $this->params->get('desc_max_words');
		$type				= $this->params->get('type');
		$verb				= $this->params->get('verb');


		if (strpos($row->fulltext,"{jlvklike_off}") !== false ) {
			$row->fulltext = preg_replace("|{jlvklike.*?}|ixm","",$row->fulltext);
			$row->text = preg_replace("|{jlvklike.*?}|ixm","",$row->text);
			$row->introtext = preg_replace("|{jlvklike.*?}|ixm","",$row->introtext);
		} else {
			$exceptcat = is_array($this->params->get('categories')) ? $this->params->get('categories') : array($this->params->get('categories'));

			if (!in_array($row->catid,$exceptcat)) {
				$view = JRequest::getCmd('view');

				if (($autoAddOnlyFull && $view == 'article') || !$autoAddOnlyFull) {
					$mainframe = &JFactory::getApplication('site');
					if (!$jlvklikeinit) {
						$script = <<<HTML
							<script type="text/javascript" src="http://userapi.com/js/api/openapi.js?1"></script>
							<script type="text/javascript">
							  VK.init({apiId: $apiId, onlyWidgets: true});
							</script>
HTML;
						$mainframe->addCustomHeadTag($script);
						$jlvklikeinit = true;
					}
					$pagehash = $row->id;
					$row->introtext = preg_replace("/\n\r|\r\n|\n|\r/", "", $row->introtext);
                    $row->introtext = preg_replace("/\t/", "", $row->introtext);
					$row->introtext = preg_replace("|<.*?>|ixm","",$row->introtext);
					$row->introtext = preg_replace("|{.*?}|ixm","",$row->introtext);
					$words = explode(" ",$row->introtext);
					$words_sliced = array_slice($words,0,intval($max_words));
					$row->introtext = implode(" ",$words_sliced)."...";
					$site = JURI::base();

					$link = $site.substr(JRoute::_(ContentHelperRoute::getArticleRoute($row->slug,$row->catslug,$row->sectionid)),1);

					$scriptPage = <<<HTML
						<br clear="all"><div id="jlvklike{$row->id}"></div>
						<script type="text/javascript">
						VK.Widgets.Like("jlvklike{$row->id}", {width: "$width", pageTitle: "{$row->title}", pageDescription: "{$row->introtext}", pageUrl: "{$link}", type: "{$type}", verb: "{$verb}"},$pagehash);
						</script>
HTML;
					if ($this->params->get('autoAdd') == 1) {
						switch($position){
							case "top":
								$row->text = $scriptPage.$row->text;
								break;
							case "bottom":
								$row->text .= $scriptPage;
								break;
						}

					} else {
						$row->text = str_replace("{jlvklike}",$scriptPage,$row->text);
					}


				}
			} else {
				$row->text = str_replace("{jlvklike}","",$row->text);
			}

		}


	}


}
